<template>
  <div
    class="dashboard"
    data-intro="Информационная панель с данными организации"
  >
    <v-row no-gutters>
      <v-col sm="4" v-if="!isAdministrator">
        <OrganizationInfo
          :contracts="contracts"
          :creditDays="organizationSettings.creditDays"
        />
      </v-col>
      <v-col sm="4">
        <ManagerInfo
          :managerInfo="serviceManager"
          :icon="icons.faceAgent"
          title="Клиентская служба"
        />
      </v-col>
      <v-col sm="4">
        <ManagerInfo
          :managerInfo="deliveryManager"
          :icon="icons.ambulance"
          title="Экспедиционный отдел"
        />
      </v-col>
      <v-col
        sm="4"
        v-if="
          this.user.settings &&
          (this.user.settings.usePharmacy == true ||
            this.user.settings.useDietarySupplement == true ||
            this.user.settings.useMedicalProducts == true)
        "
      >
        <ManagerInfo
          :managerInfo="pharmacyManager"
          :icon="icons.pharmacy"
          title='Менеджер "аптека"'
        />
      </v-col>
      <v-col sm="4" v-if="this.user.settings && this.user.settings.useCosmetic">
        <ManagerInfo
          :managerInfo="cosmeticManager"
          :icon="icons.spotlightBeam"
          title='Менеджер "косметика"'
        />
      </v-col>
      <v-col
        sm="4"
        v-if="this.user.settings && this.user.settings.useMedicalEquipment"
      >
        <ManagerInfo
          :managerInfo="medicalEquipmentManager"
          :icon="icons.medicalBag"
          title='Менеджер "медтехника"'
        />
      </v-col>
      <v-col sm="4" v-if="this.user.settings && this.user.settings.useOptics">
        <ManagerInfo
          :managerInfo="opticsManager"
          :icon="icons.glasses"
          title='Менеджер "оптика"'
        />
      </v-col>
    </v-row>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";

import { Icon } from "@/helpers";

const OrganizationInfo = () =>
  import("@/components/Dashboard/OrganizationInfo");
const ManagerInfo = () => import("@/components/Dashboard/ManagerInfo");

export default {
  props: {
    user: {
      type: Object,
      required: true,
    },
    organizationSettings: {
      type: Object,
      required: true,
    },
    contracts: {
      type: Array,
      required: true,
    },
  },
  components: {
    OrganizationInfo,
    ManagerInfo,
  },
  computed: {
    cosmeticManager() {
      return {
        Manager: "Tom Irvine",
        ManagerPhone: "(012) 123 45 67",
        ManagerEmail: "sales@company.io",
      };
    },
    medicalEquipmentManager() {
      return {
        Manager: "Jon Dow",
        ManagerPhone: "(012) 123 45 67",
        ManagerEmail: "sales-med@company.io",
      };
    },
    opticsManager() {
      return {
        Manager: "Bob Jakson",
        ManagerPhone: "(012) 123 45 67",
        ManagerEmail: "sales-optics@company.io",
      };
    },
    pharmacyManager() {
      return Object.keys(this.organizationSettings)
        .filter((propertyName) => {
          return propertyName.indexOf("pharmacy") === 0;
        })
        .reduce((obj, key) => {
          return {
            ...obj,
            [key.replace("pharmacy", "")]: this.organizationSettings[key],
          };
        }, {});
    },
    serviceManager() {
      return {
        ManagerPhone: "(012) 123 45 67",
        ManagerEmail: "service@company.io",
      };
    },
    deliveryManager() {
      return {
        ManagerPhone: "(012) 123 45 67",
        ManagerEmail: "delivery@company.io",
      };
    },
    isAdministrator() {
      return this.user.userRoles != null
        ? this.user.userRoles.includes("Administrator")
        : null;
    },
  },
  methods: {
    ...mapActions({}),
  },
  data: () => ({
    icons: {
      ambulance: Icon.ambulance,
      faceAgent: Icon.faceAgent,
      glasses: Icon.glasses,
      medicalBag: Icon.medicalBag,
      pharmacy: Icon.pharmacy,
      spotlightBeam: Icon.spotlightBeam,
    },
  }),
  mounted: async function () {},
};
</script>
